#! /usr/bin/python

import glob


def remove_backdrop(in_lines):
    out_lines = []

    remove_until_brace = False
    found_a_match = False

    for line in in_lines:
        is_comment = False

        if remove_until_brace:
            if line.strip() == '}':
                remove_until_brace = False
            continue

        if line.startswith('/*'):
            is_comment = True
        elif not line.startswith(' ') and ':backdrop' in line:
            if line.rstrip().endswith('{') or '{ /*' in line:
                if not found_a_match:
                    remove_until_brace = True
                if out_lines[-1].rstrip().endswith(','):
                    out_lines[-1] = out_lines[-1].rstrip()[:-1] + ' {\n'
            continue

        if is_comment or not line.strip():
            pass
        elif line.startswith('@'):
            found_a_match = False
        elif line.startswith(' '):
            found_a_match = False
        elif line.rstrip() == '}':
            found_a_match = False
        else:
            found_a_match = True

        out_lines.append(line)

    return ''.join(out_lines)

def count(data, what):
    res = 0
    for c in data:
        if c == what:
            res += 1

    return res

for f in glob.glob('*.css'):
    fin = open(f, 'r')
    data = remove_backdrop(fin.readlines())
    fin.close()
    assert count(data, '{') == count(data, '}')
    fout = open(f, 'w')
    fout.write(data)
    fout.close()
